#include "Characte.h"

Consecutive::Consecutive(std::string & l): BEFORE("F"), COLON(":"), EMPTY(""), GAP(" "), ID_COLON(" ID:"), MARK("^"), N_0TO9("0123456789"), YOBI("ΐ؋y") {
    const std::string MONTH_TIME("/05/ 08:");
    const std::string no("No error");
    const std::string PU(" | ");
    const std::string W0("Sun");
    const std::string W1("Mon");
    const std::string W2("Tue");
    const std::string W3("Wed");
    const std::string W4("Thu");
    const std::string W5("Fri");
    const std::string W6("Sat");
    const std::string YEN("\n");

    date = EMPTY;
    day = EMPTY;
    gap_id = EMPTY;
    line = l;
    name = EMPTY;
    no_error = no;
    PUNCTUATION = PU;
    readyToRebuild = false;
    res_no = EMPTY;
    res_time = EMPTY;
    session = 0;

    features = MONTH_TIME;
    featuresLength = features.length();

    d = new GapID();
    error = no_error;

    weekdays[0] = W0;
    weekdays[1] = W1;
    weekdays[2] = W2;
    weekdays[3] = W3;
    weekdays[4] = W4;
    weekdays[5] = W5;
    weekdays[6] = W6;
}

int Consecutive::dateLine() {
    using namespace std;

    lineLength = line.length();
    if(lineLength < featuresLength) {
        return NON_DATE_LINE;
    }

    string c = line.substr(MARK_INDEX, 1);
    if(c == MARK) {
        return DATE_LINE;
    }

    int p;
    int r[ARRAY_SIZE];

    c = line.substr(0, 1);
    p = N_0TO9.find(c);
    if(p != string::npos) { // res-number
        ;
    } else {
        return NON_DATE_LINE;
    }

    int g = strspn( line.c_str(), "0123456789");
    if(g <= 4) {
        head = line.substr(0, g);
        tail = line.substr(g);
        r[0] = tail.find("/01/");
        r[1] = tail.find("/02/");
        r[2] = tail.find("/03/");
        r[3] = tail.find("/04/");
        r[4] = tail.find("/05/");
        r[5] = tail.find("/06/");
        r[6] = tail.find("/07/");
        r[7] = tail.find("/08/");
        r[8] = tail.find("/09/");
        r[9] = tail.find("/10/");
        r[10] = tail.find("/11/");
        r[11] = tail.find("/12/");
        int k = 0;
        p = tail.length();
        for(int i = 0; i < TWELVE_MONTHS; ++i) {
            if(r[i] != string::npos) {
                p = r[i];
                ++k;
            }

        }

        if(k == 1) { // A slash-month-slash sequence can be found.
            int slash_month_slash = g + p;
            p += SLASH_MONTH_SLASH_SIZE;

// If a colon appears, it shall be removed from the first part of the name.
            c = tail.substr(0, BEFORE_SIZE);
            if(BEFORE == c) { // "F" in Shift_JIS
                name = tail.substr(BEFORE_SIZE, p - BEFORE_SIZE );
            } else {
                c = tail.substr(0, GAP_SIZE);
                if(GAP == c) {
                    c = tail.substr(GAP_SIZE, BEFORE_SIZE);
                    if(BEFORE == c) {
                        const int GAP_BEFORE_SIZE = GAP_SIZE + BEFORE_SIZE; // " F" in Shift_JIS
                        name = tail.substr(GAP_BEFORE_SIZE, p - GAP_BEFORE_SIZE );
                    } else {
                        c = tail.substr(GAP_SIZE, COLON_SIZE);
                        if(COLON == c) {
                            const int GAP_COLON_SIZE = GAP_SIZE + COLON_SIZE; // " :"
                            name = tail.substr(GAP_COLON_SIZE, p - GAP_COLON_SIZE );
                        } else {
                            name = tail.substr(0, p);
                        }

                    }

                } else {
                    name = tail.substr(0, p);
                }

            }

            int n = name.rfind(GAP);
            if(n != string::npos) {
                name = name.substr(0, n);
            }

            tail = tail.substr(p);
            r[0] = tail.find(" 00:");
            r[1] = tail.find(" 01:");
            r[2] = tail.find(" 02:");
            r[3] = tail.find(" 03:");
            r[4] = tail.find(" 04:");
            r[5] = tail.find(" 05:");
            r[6] = tail.find(" 06:");
            r[7] = tail.find(" 07:");
            r[8] = tail.find(" 08:");
            r[9] = tail.find(" 09:");
            r[10] = tail.find(" 10:");
            r[11] = tail.find(" 11:");
            r[12] = tail.find(" 12:");
            r[13] = tail.find(" 13:");
            r[14] = tail.find(" 14:");
            r[15] = tail.find(" 15:");
            r[16] = tail.find(" 16:");
            r[17] = tail.find(" 17:");
            r[18] = tail.find(" 18:");
            r[19] = tail.find(" 19:");
            r[20] = tail.find(" 20:");
            r[21] = tail.find(" 21:");
            r[22] = tail.find(" 22:");
            r[23] = tail.find(" 23:"); // 2ch
            r[24] = tail.find(")00:"); // Open2ch
            r[25] = tail.find(")01:");
            r[26] = tail.find(")02:");
            r[27] = tail.find(")03:");
            r[28] = tail.find(")04:");
            r[29] = tail.find(")05:");
            r[30] = tail.find(")06:");
            r[31] = tail.find(")07:");
            r[32] = tail.find(")08:");
            r[33] = tail.find(")09:");
            r[34] = tail.find(")10:");
            r[35] = tail.find(")11:");
            r[36] = tail.find(")12:");
            r[37] = tail.find(")13:");
            r[38] = tail.find(")14:");
            r[39] = tail.find(")15:");
            r[40] = tail.find(")16:");
            r[41] = tail.find(")17:");
            r[42] = tail.find(")18:");
            r[43] = tail.find(")19:");
            r[44] = tail.find(")20:");
            r[45] = tail.find(")21:");
            r[46] = tail.find(")22:");
            r[47] = tail.find(")23:");
            k = 0;
            p = tail.length();
            for(int i = 0; i < ARRAY_SIZE; ++i) {
                if(r[i] != string::npos) {
                    p = r[i];
                    ++k;
                }

            }

            if(k == 1) {
                int beginning_of_time = p + 1;

// ID
                p = line.find(ID_COLON);
                if(p != string::npos) {
                    gap_id = line.substr(p);
                    int idLength = gap_id.length();
                    if( idLength < SPACE_WIDTH ) {
                        gap_id = padding(gap_id);
                    }

                } else {
                    int u = line.find(BEFORE);
                    if(u != string::npos) {
                        const string wide_space(WIDE_SPACE);
                        gap_id = wide_space;
                    } else {
                        return NON_DATE_LINE;
                    }

                }

// res time
                tail = tail.substr(beginning_of_time);
                p = tail.find(GAP);
                if(p != string::npos) {
                    res_time = tail.substr(0, p); // 07:13:18
                } else {
                    res_time = tail;
                }

                int timeLength = res_time.length();
                if( timeLength < SPACE_WIDTH ) {
                    res_time = padding(res_time);
                }

// date
                int m = slash_month_slash - 2;
                int w = m + DATE_SIZE; 
                const string HEAD = "20";
                tail = line.substr(m, DATE_SIZE); // 11/06/06
                date = HEAD + tail;
                string YEAR_SLASH = date.substr(0, YEAR_SLASH_SIZE);

                c = line.substr(w, 1);
                const string PARENTHESIS("(");
                const string CLOSE_BRACKET(")");
                if(c == PARENTHESIS) {
                    int e = w + 1;
                    c = line.substr(e, KANJI_SIZE);
                    p = YOBI.find(c);
                    if(p != string::npos) {
                        stringstream os;
                        os << PARENTHESIS << weekdays[ p/KANJI_SIZE ] << CLOSE_BRACKET;
                        day = os.str();
                    } else {
                        tail = line.substr(w);
                        int l = tail.find(CLOSE_BRACKET);
                        ++l;
                        day = line.substr(w, l); // (Fri) for example
                    }

                }

// res number
                res_no = line.substr(0, g);

// Removing YEAR_SLASH from name
                p = name.rfind(YEAR_SLASH);
                if(p != string::npos) {
                    name = name.substr(0, p);
                }

// Removing TOKOBI from name
                p = name.rfind(TOKOBI);
                if(p != string::npos) {
                    name = name.substr(0, p);
                }

                readyToRebuild = true;
                return m;
            }

        }

    }

    return NON_DATE_LINE;
}

std::string Consecutive::fixedWidth(int n, char c, int width) {
    using namespace std;

    char *pad = new char[ width + 1 ];
    for(int i = 0; i < width; ++i) {
        pad[i] = c;
    }

    pad[width] = '\0';
    string *p = new string(pad);

    stringstream os;
    os << n;
    string tail = os.str();
    int number_length = tail.length();

    int q = width - number_length;
    string head = p->substr(0, q);
    string fixed_width_number = head + tail;

    delete pad;
    return fixed_width_number;
}

std::string Consecutive::rebuild() {
    using namespace std;

    if(readyToRebuild) {
        stringstream os;
        res_time = resTime();

        int res_number = stringToInteger(res_no);
        res_number += 1;

        os << res_number;

// Every name is interposed between colons.
        os << GAP << BEFORE << name << GAP << BEFORE;

        os << date << day << GAP << res_time << gap_id;
        line = os.str();

        int g = line.find(GAP);
        res_no = line.substr(0, g);

        session += 1;
        if( session%REPEATED_POST == 0 ) {
            gap_id = d->gapID();
            if( gap_id.length() == 0 ) {
                if(session == REPEATED_POST) {
                    string SESSION_REPEATED_POST_ERROR = d->inquiry();
                    plus(SESSION_REPEATED_POST_ERROR);
                }

            }

        }

    }

    return line;
}

std::string Consecutive::resTime() {
    using namespace std;

    time_t res_seconds;
    time_t *timer = &res_seconds;
    time(timer);
    struct tm *t = localtime(timer);

    int q = res_time.find(GAP);
    string sequence;
    if(q != string::npos) {
        sequence = res_time;
    } else {
        sequence = res_time.substr(0, q);
    }

    int sequenceLength = sequence.length();
    if(sequenceLength < HOURS_MINUTES_SIZE) {
        const string NOON("00:00:00");
        sequence = NOON;
    } else if(sequenceLength < HOURS_MINUTES_SECONDS_SIZE) {
        const string CLEAR(":00");
        sequence += CLEAR;
    }

    string hours = sequence.substr(0, 2);
    t->tm_hour = stringToInteger(hours);

    string minutes = sequence.substr(3, 2);
    t->tm_min = stringToInteger(minutes);

    string seconds = sequence.substr(6, 2);
    t->tm_sec = stringToInteger(seconds);

    res_seconds = mktime(t);
    res_seconds += BREAK_TIME;
    t = localtime(timer); // timer = &res_seconds

/*
012345678901234567890123
Mon Jul 18 07:13:18 2016
Mon Jul 18 07:13:43 2016
Mon Jul 18 07:14:08 2016
*/
    string ascii( asctime(t) );
    return ascii.substr(11, HOURS_MINUTES_SECONDS_SIZE);
}
