#include "Characte.h"

bool GapID::readRannuText() {
    using namespace std;

    const string CLOSE_BRACKET(" )");
    int c0, c1;
    int k = 0;
    string line;

// Using RANNU_TEXT as binary
    ifstream in( RANNU_TEXT.c_str(), ios::binary);
    if( in.fail() ) {
        error = "e50: ifstream in( " + RANNU_TEXT + ", ios::binary" + CLOSE_BRACKET;
        return false;
    }

    in.seekg(0, ios::end);
    streampos length = in.tellg();
    int file_size = (int)length;
    in.close();

// random-number table
    delete random_number;
    random_number = new int[ file_size/3 ];

// Reopening RANNU_TEXT
    char *b;
    char c[RAW_BUFFER_SIZE];
    ifstream file( RANNU_TEXT.c_str() );
    while( file.getline(c, RAW_BUFFER_SIZE) ) {
        for(b = &c[0]; *b != '\0'; ++b) {
            c0 = (int) *b;
            if(c0 == GAP_C) {
                continue;
            }

            ++b;
            if(*b != '\0') {
                c1 = (int) *b;
                if(c1 == GAP_C) {
                    c1 = COMPLEMENTARY;
                }

                random_number[k++] = two_digit_number[c0][c1];
            } else {
                break;
            }

        }

    }

    file.close();
    table_size = (long)k;
    return true;
}

GapID::GapID(): EMPTY(""), GAP(" "), ID_COLON(" ID:"), RANNU_TEXT("rannu.txt"), w0(""), w1("/"), w2("3"), w3("b"), w4("E"), w5("6"), w6("K"), w7("y"), w8("c"), w9("h"), w10("z"), w11("J"), w12("7"), w13("g"), w14("p"), w15("Y"), w16("o"), w17("5"), w18("w"), w19("F"), w20("I"), w21("1"), w22("G"), w23("s"), w24("A"), w25("P"), w26("L"), w27("2"), w28("T"), w29("X"), w30("9"), w31("V"), w32("x"), w33("j"), w34("+"), w35("R"), w36("H"), w37("d"), w38("M"), w39("e"), w40("N"), w41("q"), w42("Z"), w43("D"), w44("C"), w45("v"), w46("n"), w47("B"), w48("8"), w49("k"), w50("f"), w51("W"), w52("U"), w53("0"), w54("S"), w55("O"), w56("4"), w57("u"), w58("Q"), w59("a"), w60("t"), w61("r"), w62("i"), w63("m"), w64("l") {
    C[0] = w1; C[1] = w2; C[2] = w3; C[3] = w4; C[4] = w5; C[5] = w6; C[6] = w7; C[7] = w8; C[8] = w9; C[9] = w10; C[10] = w11; C[11] = w12; C[12] = w13; C[13] = w14; C[14] = w15; C[15] = w16; C[16] = w17; C[17] = w18; C[18] = w19; C[19] = w20;
    C[20] = w21; C[21] = w22; C[22] = w23; C[23] = w24; C[24] = w25; C[25] = w26; C[26] = w27; C[27] = w28; C[28] = w29; C[29] = w30; C[30] = w31; C[31] = w32; C[32] = w33; C[33] = w34; C[34] = w35; C[35] = w36; C[36] = w37; C[37] = w38; C[38] = w39; C[39] = w40;
    C[40] = w41; C[41] = w42; C[42] = w43; C[43] = w44; C[44] = w45; C[45] = w46; C[46] = w47; C[47] = w48; C[48] = w49; C[49] = w50; C[50] = w51; C[51] = w52; C[52] = w53; C[53] = w54; C[54] = w55; C[55] = w56; C[56] = w57; C[57] = w58; C[58] = w59; C[59] = w60;
    C[60] = w61; C[61] = w62; C[62] = w63; C[63] = w64; 
    random_number = new int[1];
    session = 0;
    two_digit_number['0']['0'] = 0; two_digit_number['0']['1'] = 1; two_digit_number['0']['2'] = 2; two_digit_number['0']['3'] = 3; two_digit_number['0']['4'] = 4; two_digit_number['0']['5'] = 5; two_digit_number['0']['6'] = 6; two_digit_number['0']['7'] = 7; two_digit_number['0']['8'] = 8; two_digit_number['0']['9'] = 9; 
    two_digit_number['1']['0'] = 10; two_digit_number['1']['1'] = 11; two_digit_number['1']['2'] = 12; two_digit_number['1']['3'] = 13; two_digit_number['1']['4'] = 14; two_digit_number['1']['5'] = 15; two_digit_number['1']['6'] = 16; two_digit_number['1']['7'] = 17; two_digit_number['1']['8'] = 18; two_digit_number['1']['9'] = 19; 
    two_digit_number['2']['0'] = 20; two_digit_number['2']['1'] = 21; two_digit_number['2']['2'] = 22; two_digit_number['2']['3'] = 23; two_digit_number['2']['4'] = 24; two_digit_number['2']['5'] = 25; two_digit_number['2']['6'] = 26; two_digit_number['2']['7'] = 27; two_digit_number['2']['8'] = 28; two_digit_number['2']['9'] = 29; 
    two_digit_number['3']['0'] = 30; two_digit_number['3']['1'] = 31; two_digit_number['3']['2'] = 32; two_digit_number['3']['3'] = 33; two_digit_number['3']['4'] = 34; two_digit_number['3']['5'] = 35; two_digit_number['3']['6'] = 36; two_digit_number['3']['7'] = 37; two_digit_number['3']['8'] = 38; two_digit_number['3']['9'] = 39; 
    two_digit_number['4']['0'] = 40; two_digit_number['4']['1'] = 41; two_digit_number['4']['2'] = 42; two_digit_number['4']['3'] = 43; two_digit_number['4']['4'] = 44; two_digit_number['4']['5'] = 45; two_digit_number['4']['6'] = 46; two_digit_number['4']['7'] = 47; two_digit_number['4']['8'] = 48; two_digit_number['4']['9'] = 49; 
    two_digit_number['5']['0'] = 50; two_digit_number['5']['1'] = 51; two_digit_number['5']['2'] = 52; two_digit_number['5']['3'] = 53; two_digit_number['5']['4'] = 54; two_digit_number['5']['5'] = 55; two_digit_number['5']['6'] = 56; two_digit_number['5']['7'] = 57; two_digit_number['5']['8'] = 58; two_digit_number['5']['9'] = 59; 
    two_digit_number['6']['0'] = 60; two_digit_number['6']['1'] = 61; two_digit_number['6']['2'] = 62; two_digit_number['6']['3'] = 63; two_digit_number['6']['4'] = 64; two_digit_number['6']['5'] = 65; two_digit_number['6']['6'] = 66; two_digit_number['6']['7'] = 67; two_digit_number['6']['8'] = 68; two_digit_number['6']['9'] = 69; 
    two_digit_number['7']['0'] = 70; two_digit_number['7']['1'] = 71; two_digit_number['7']['2'] = 72; two_digit_number['7']['3'] = 73; two_digit_number['7']['4'] = 74; two_digit_number['7']['5'] = 75; two_digit_number['7']['6'] = 76; two_digit_number['7']['7'] = 77; two_digit_number['7']['8'] = 78; two_digit_number['7']['9'] = 79; 
    two_digit_number['8']['0'] = 80; two_digit_number['8']['1'] = 81; two_digit_number['8']['2'] = 82; two_digit_number['8']['3'] = 83; two_digit_number['8']['4'] = 84; two_digit_number['8']['5'] = 85; two_digit_number['8']['6'] = 86; two_digit_number['8']['7'] = 87; two_digit_number['8']['8'] = 88; two_digit_number['8']['9'] = 89; 
    two_digit_number['9']['0'] = 90; two_digit_number['9']['1'] = 91; two_digit_number['9']['2'] = 92; two_digit_number['9']['3'] = 93; two_digit_number['9']['4'] = 94; two_digit_number['9']['5'] = 95; two_digit_number['9']['6'] = 96; two_digit_number['9']['7'] = 97; two_digit_number['9']['8'] = 98; two_digit_number['9']['9'] = 99; 
    xorshift = new Xorshift(0);
}

std::string GapID::gapID() {
    using namespace std;

// Reading RANNU_TEXT to produce a random-number array
    if(! readRannuText() ) {
        return EMPTY;
    }

// Randomly selecting u so that the array index starts from u.
    int interval_0 = 0;
    int interval_1 = (int)table_size - 1;
    double difference = (double)( interval_1 - interval_0 + 1 );
    double range = difference/4294967296.0;
    unsigned int g = xorshift->nextRandom(); // 0 to 4294967295

    int plus = (int) floor( range * (double)g );
    int u = interval_0 + plus;
    u += session;

// Producing new ID
    int b;
    stringstream os;
    os << ID_COLON;
    for(int i = 0; i < ID_SIZE; ++i) {
        b = random_number[u++];
        if(u >= table_size) {
            u = 0;
        }

        if(b >= C_ARRAY_SIZE) {
            b = C_ARRAY_SIZE - 1;
        }

        os << C[b];
    }

    string s = os.str();
    session += 1;
    return s;
}
