#include "ToFive.h"

bool ToFive::wrongBall(std::string & s) {
    bool wrong = true;
    error = "e51: wrongBall()";

    for(int i = 1; i <= ALL; ++i) {
        if(s == ball[i]) {
            wrong = false;
            error = "e52: s == ball[i]";
            break;
        }

    }

    return wrong;
}

int ToFive::writeFile() {
    int result = FALSE_N;
    sequenceLength = sequence.length();
    to5 = sequence.substr( sequenceLength - 5, 5);
    s01 = sequence.substr(0, 3);
    if( wrongBall(s01) ) {
        return result;
    }

    s02 = sequence.substr(3, 3);
    if( wrongBall(s02) ) {
        return result;
    }

    s03 = sequence.substr(6, 3);
    if( wrongBall(s03) ) {
        return result;
    }

    s04 = sequence.substr(9, 3);
    if( wrongBall(s04) ) {
        return result;
    }

    s05 = sequence.substr(12, 3);
    if( wrongBall(s05) ) {
        return result;
    }

    s06 = sequence.substr(15, 3);
    if( wrongBall(s06) ) {
        return result;
    }

    if(BOX_6TO5 == to5) {
        result = file6to5();
    } else if(BOX_7TO5 == to5) {
        s07 = sequence.substr(18, 3);
        result = file7to5();
    } else if(BOX_8TO5 == to5) {
        s07 = sequence.substr(18, 3);
        s08 = sequence.substr(21, 3);
        result = file8to5();
    } else if(BOX_9TO5 == to5) {
        s07 = sequence.substr(18, 3);
        s08 = sequence.substr(21, 3);
        s09 = sequence.substr(24, 3);
        result = file9to5();
    }

    return result;
}

int ToFive::file6to5() {
    using namespace std;

    ofstream file( fileName.c_str() );
    if( file.fail() ) {
        return FALSE_N;
    }

file << s01 << s02 << s03 << s04 << s05 << endl
<< s01 << s02 << s03 << s04 << s06 << endl
<< s01 << s02 << s03 << s05 << s06 << endl
<< s01 << s02 << s04 << s05 << s06 << endl
<< s01 << s03 << s04 << s05 << s06 << endl
<< s02 << s03 << s04 << s05 << s06 << endl;
    file.close();
    return TRUE_N;
}

int ToFive::file7to5() {
    using namespace std;

    ofstream file( fileName.c_str() );
    if( file.fail() ) {
        return FALSE_N;
    }

file << s01 << s02 << s03 << s04 << s05 << endl
<< s01 << s02 << s03 << s04 << s06 << endl
<< s01 << s02 << s03 << s04 << s07 << endl
<< s01 << s02 << s03 << s05 << s06 << endl
<< s01 << s02 << s03 << s05 << s07 << endl
<< s01 << s02 << s03 << s06 << s07 << endl
<< s01 << s02 << s04 << s05 << s06 << endl
<< s01 << s02 << s04 << s05 << s07 << endl
<< s01 << s02 << s04 << s06 << s07 << endl
<< s01 << s02 << s05 << s06 << s07 << endl
<< s01 << s03 << s04 << s05 << s06 << endl
<< s01 << s03 << s04 << s05 << s07 << endl
<< s01 << s03 << s04 << s06 << s07 << endl
<< s01 << s03 << s05 << s06 << s07 << endl
<< s01 << s04 << s05 << s06 << s07 << endl
<< s02 << s03 << s04 << s05 << s06 << endl
<< s02 << s03 << s04 << s05 << s07 << endl
<< s02 << s03 << s04 << s06 << s07 << endl
<< s02 << s03 << s05 << s06 << s07 << endl
<< s02 << s04 << s05 << s06 << s07 << endl
<< s03 << s04 << s05 << s06 << s07 << endl;
    file.close();
    return TRUE_N;
}

int ToFive::file8to5() {
    using namespace std;

    ofstream file( fileName.c_str() );
    if( file.fail() ) {
        return FALSE_N;
    }

file << s01 << s02 << s03 << s04 << s05 << endl
<< s01 << s02 << s03 << s04 << s06 << endl
<< s01 << s02 << s03 << s04 << s07 << endl
<< s01 << s02 << s03 << s04 << s08 << endl
<< s01 << s02 << s03 << s05 << s06 << endl
<< s01 << s02 << s03 << s05 << s07 << endl
<< s01 << s02 << s03 << s05 << s08 << endl
<< s01 << s02 << s03 << s06 << s07 << endl
<< s01 << s02 << s03 << s06 << s08 << endl
<< s01 << s02 << s03 << s07 << s08 << endl
<< s01 << s02 << s04 << s05 << s06 << endl
<< s01 << s02 << s04 << s05 << s07 << endl
<< s01 << s02 << s04 << s05 << s08 << endl
<< s01 << s02 << s04 << s06 << s07 << endl
<< s01 << s02 << s04 << s06 << s08 << endl
<< s01 << s02 << s04 << s07 << s08 << endl
<< s01 << s02 << s05 << s06 << s07 << endl
<< s01 << s02 << s05 << s06 << s08 << endl
<< s01 << s02 << s05 << s07 << s08 << endl
<< s01 << s02 << s06 << s07 << s08 << endl
<< s01 << s03 << s04 << s05 << s06 << endl
<< s01 << s03 << s04 << s05 << s07 << endl
<< s01 << s03 << s04 << s05 << s08 << endl
<< s01 << s03 << s04 << s06 << s07 << endl
<< s01 << s03 << s04 << s06 << s08 << endl
<< s01 << s03 << s04 << s07 << s08 << endl
<< s01 << s03 << s05 << s06 << s07 << endl
<< s01 << s03 << s05 << s06 << s08 << endl
<< s01 << s03 << s05 << s07 << s08 << endl
<< s01 << s03 << s06 << s07 << s08 << endl
<< s01 << s04 << s05 << s06 << s07 << endl
<< s01 << s04 << s05 << s06 << s08 << endl
<< s01 << s04 << s05 << s07 << s08 << endl
<< s01 << s04 << s06 << s07 << s08 << endl
<< s01 << s05 << s06 << s07 << s08 << endl
<< s02 << s03 << s04 << s05 << s06 << endl
<< s02 << s03 << s04 << s05 << s07 << endl
<< s02 << s03 << s04 << s05 << s08 << endl
<< s02 << s03 << s04 << s06 << s07 << endl
<< s02 << s03 << s04 << s06 << s08 << endl
<< s02 << s03 << s04 << s07 << s08 << endl
<< s02 << s03 << s05 << s06 << s07 << endl
<< s02 << s03 << s05 << s06 << s08 << endl
<< s02 << s03 << s05 << s07 << s08 << endl
<< s02 << s03 << s06 << s07 << s08 << endl
<< s02 << s04 << s05 << s06 << s07 << endl
<< s02 << s04 << s05 << s06 << s08 << endl
<< s02 << s04 << s05 << s07 << s08 << endl
<< s02 << s04 << s06 << s07 << s08 << endl
<< s02 << s05 << s06 << s07 << s08 << endl
<< s03 << s04 << s05 << s06 << s07 << endl
<< s03 << s04 << s05 << s06 << s08 << endl
<< s03 << s04 << s05 << s07 << s08 << endl
<< s03 << s04 << s06 << s07 << s08 << endl
<< s03 << s05 << s06 << s07 << s08 << endl
<< s04 << s05 << s06 << s07 << s08 << endl;
    file.close();
    return TRUE_N;
}

int ToFive::file9to5() {
    using namespace std;

    ofstream file( fileName.c_str() );
    if( file.fail() ) {
        return FALSE_N;
    }

file << s01 << s02 << s03 << s04 << s05 << endl
<< s01 << s02 << s03 << s04 << s06 << endl
<< s01 << s02 << s03 << s04 << s07 << endl
<< s01 << s02 << s03 << s04 << s08 << endl
<< s01 << s02 << s03 << s04 << s09 << endl
<< s01 << s02 << s03 << s05 << s06 << endl
<< s01 << s02 << s03 << s05 << s07 << endl
<< s01 << s02 << s03 << s05 << s08 << endl
<< s01 << s02 << s03 << s05 << s09 << endl
<< s01 << s02 << s03 << s06 << s07 << endl
<< s01 << s02 << s03 << s06 << s08 << endl
<< s01 << s02 << s03 << s06 << s09 << endl
<< s01 << s02 << s03 << s07 << s08 << endl
<< s01 << s02 << s03 << s07 << s09 << endl
<< s01 << s02 << s03 << s08 << s09 << endl
<< s01 << s02 << s04 << s05 << s06 << endl
<< s01 << s02 << s04 << s05 << s07 << endl
<< s01 << s02 << s04 << s05 << s08 << endl
<< s01 << s02 << s04 << s05 << s09 << endl
<< s01 << s02 << s04 << s06 << s07 << endl
<< s01 << s02 << s04 << s06 << s08 << endl
<< s01 << s02 << s04 << s06 << s09 << endl
<< s01 << s02 << s04 << s07 << s08 << endl
<< s01 << s02 << s04 << s07 << s09 << endl
<< s01 << s02 << s04 << s08 << s09 << endl
<< s01 << s02 << s05 << s06 << s07 << endl
<< s01 << s02 << s05 << s06 << s08 << endl
<< s01 << s02 << s05 << s06 << s09 << endl
<< s01 << s02 << s05 << s07 << s08 << endl
<< s01 << s02 << s05 << s07 << s09 << endl
<< s01 << s02 << s05 << s08 << s09 << endl
<< s01 << s02 << s06 << s07 << s08 << endl
<< s01 << s02 << s06 << s07 << s09 << endl
<< s01 << s02 << s06 << s08 << s09 << endl
<< s01 << s02 << s07 << s08 << s09 << endl
<< s01 << s03 << s04 << s05 << s06 << endl
<< s01 << s03 << s04 << s05 << s07 << endl
<< s01 << s03 << s04 << s05 << s08 << endl
<< s01 << s03 << s04 << s05 << s09 << endl
<< s01 << s03 << s04 << s06 << s07 << endl
<< s01 << s03 << s04 << s06 << s08 << endl
<< s01 << s03 << s04 << s06 << s09 << endl
<< s01 << s03 << s04 << s07 << s08 << endl
<< s01 << s03 << s04 << s07 << s09 << endl
<< s01 << s03 << s04 << s08 << s09 << endl
<< s01 << s03 << s05 << s06 << s07 << endl
<< s01 << s03 << s05 << s06 << s08 << endl
<< s01 << s03 << s05 << s06 << s09 << endl
<< s01 << s03 << s05 << s07 << s08 << endl
<< s01 << s03 << s05 << s07 << s09 << endl
<< s01 << s03 << s05 << s08 << s09 << endl
<< s01 << s03 << s06 << s07 << s08 << endl
<< s01 << s03 << s06 << s07 << s09 << endl
<< s01 << s03 << s06 << s08 << s09 << endl
<< s01 << s03 << s07 << s08 << s09 << endl
<< s01 << s04 << s05 << s06 << s07 << endl
<< s01 << s04 << s05 << s06 << s08 << endl
<< s01 << s04 << s05 << s06 << s09 << endl
<< s01 << s04 << s05 << s07 << s08 << endl
<< s01 << s04 << s05 << s07 << s09 << endl
<< s01 << s04 << s05 << s08 << s09 << endl
<< s01 << s04 << s06 << s07 << s08 << endl
<< s01 << s04 << s06 << s07 << s09 << endl
<< s01 << s04 << s06 << s08 << s09 << endl
<< s01 << s04 << s07 << s08 << s09 << endl
<< s01 << s05 << s06 << s07 << s08 << endl
<< s01 << s05 << s06 << s07 << s09 << endl
<< s01 << s05 << s06 << s08 << s09 << endl
<< s01 << s05 << s07 << s08 << s09 << endl
<< s01 << s06 << s07 << s08 << s09 << endl
<< s02 << s03 << s04 << s05 << s06 << endl
<< s02 << s03 << s04 << s05 << s07 << endl
<< s02 << s03 << s04 << s05 << s08 << endl
<< s02 << s03 << s04 << s05 << s09 << endl
<< s02 << s03 << s04 << s06 << s07 << endl
<< s02 << s03 << s04 << s06 << s08 << endl
<< s02 << s03 << s04 << s06 << s09 << endl
<< s02 << s03 << s04 << s07 << s08 << endl
<< s02 << s03 << s04 << s07 << s09 << endl
<< s02 << s03 << s04 << s08 << s09 << endl
<< s02 << s03 << s05 << s06 << s07 << endl
<< s02 << s03 << s05 << s06 << s08 << endl
<< s02 << s03 << s05 << s06 << s09 << endl
<< s02 << s03 << s05 << s07 << s08 << endl
<< s02 << s03 << s05 << s07 << s09 << endl
<< s02 << s03 << s05 << s08 << s09 << endl
<< s02 << s03 << s06 << s07 << s08 << endl
<< s02 << s03 << s06 << s07 << s09 << endl
<< s02 << s03 << s06 << s08 << s09 << endl
<< s02 << s03 << s07 << s08 << s09 << endl;

file << s02 << s04 << s05 << s06 << s07 << endl
<< s02 << s04 << s05 << s06 << s08 << endl
<< s02 << s04 << s05 << s06 << s09 << endl
<< s02 << s04 << s05 << s07 << s08 << endl
<< s02 << s04 << s05 << s07 << s09 << endl
<< s02 << s04 << s05 << s08 << s09 << endl
<< s02 << s04 << s06 << s07 << s08 << endl
<< s02 << s04 << s06 << s07 << s09 << endl
<< s02 << s04 << s06 << s08 << s09 << endl
<< s02 << s04 << s07 << s08 << s09 << endl
<< s02 << s05 << s06 << s07 << s08 << endl
<< s02 << s05 << s06 << s07 << s09 << endl
<< s02 << s05 << s06 << s08 << s09 << endl
<< s02 << s05 << s07 << s08 << s09 << endl
<< s02 << s06 << s07 << s08 << s09 << endl
<< s03 << s04 << s05 << s06 << s07 << endl
<< s03 << s04 << s05 << s06 << s08 << endl
<< s03 << s04 << s05 << s06 << s09 << endl
<< s03 << s04 << s05 << s07 << s08 << endl
<< s03 << s04 << s05 << s07 << s09 << endl
<< s03 << s04 << s05 << s08 << s09 << endl
<< s03 << s04 << s06 << s07 << s08 << endl
<< s03 << s04 << s06 << s07 << s09 << endl
<< s03 << s04 << s06 << s08 << s09 << endl
<< s03 << s04 << s07 << s08 << s09 << endl
<< s03 << s05 << s06 << s07 << s08 << endl
<< s03 << s05 << s06 << s07 << s09 << endl
<< s03 << s05 << s06 << s08 << s09 << endl
<< s03 << s05 << s07 << s08 << s09 << endl
<< s03 << s06 << s07 << s08 << s09 << endl
<< s04 << s05 << s06 << s07 << s08 << endl
<< s04 << s05 << s06 << s07 << s09 << endl
<< s04 << s05 << s06 << s08 << s09 << endl
<< s04 << s05 << s07 << s08 << s09 << endl
<< s04 << s06 << s07 << s08 << s09 << endl
<< s05 << s06 << s07 << s08 << s09 << endl;
    file.close();
    return TRUE_N;
}
