#include "ToSix.h"

bool ToSix::wrongBall(std::string & s) {
    bool wrong = true;
    error = "e55: wrongBall()";

    for(int i = 1; i <= ALL; ++i) {
        if(s == ball[i]) {
            wrong = false;
            error = "e56: s == ball[i]";
            break;
        }

    }

    return wrong;
}

int ToSix::writeFile() {
    int result = FALSE_N;
    sequenceLength = sequence.length();
    to6 = sequence.substr( sequenceLength - 5, 5);
    s01 = sequence.substr(0, 3);
    if( wrongBall(s01) ) {
        return result;
    }

    s02 = sequence.substr(3, 3);
    if( wrongBall(s02) ) {
        return result;
    }

    s03 = sequence.substr(6, 3);
    if( wrongBall(s03) ) {
        return result;
    }

    s04 = sequence.substr(9, 3);
    if( wrongBall(s04) ) {
        return result;
    }

    s05 = sequence.substr(12, 3);
    if( wrongBall(s05) ) {
        return result;
    }

    s06 = sequence.substr(15, 3);
    if( wrongBall(s06) ) {
        return result;
    }

    s07 = sequence.substr(18, 3);
    if( wrongBall(s07) ) {
        return result;
    }

    if(BOX_7TO6 == to6) {
        result = file7to6();
    } else if(BOX_8TO6 == to6) {
        s08 = sequence.substr(21, 3);
        result = file8to6();
    } else if(BOX_9TO6 == to6) {
        s08 = sequence.substr(21, 3);
        s09 = sequence.substr(24, 3);
        result = file9to6();
    } else if(BOX_10TO6 == to6) {
        s08 = sequence.substr(21, 3);
        s09 = sequence.substr(24, 3);
        s10 = sequence.substr(27, 3);
        result = file10to6();
    }

    return result;
}

int ToSix::file7to6() {
    using namespace std;

    ofstream file( fileName.c_str() );
    if( file.fail() ) {
        return FALSE_N;
    }

file << s01 << s02 << s03 << s04 << s05 << s06 << endl
<< s01 << s02 << s03 << s04 << s05 << s07 << endl
<< s01 << s02 << s03 << s04 << s06 << s07 << endl
<< s01 << s02 << s03 << s05 << s06 << s07 << endl
<< s01 << s02 << s04 << s05 << s06 << s07 << endl
<< s01 << s03 << s04 << s05 << s06 << s07 << endl
<< s02 << s03 << s04 << s05 << s06 << s07 << endl;
    file.close();
    return TRUE_N;
}

int ToSix::file8to6() {
    using namespace std;

    ofstream file( fileName.c_str() );
    if( file.fail() ) {
        return FALSE_N;
    }

file << s01 << s02 << s03 << s04 << s05 << s06 << endl
<< s01 << s02 << s03 << s04 << s05 << s07 << endl
<< s01 << s02 << s03 << s04 << s05 << s08 << endl
<< s01 << s02 << s03 << s04 << s06 << s07 << endl
<< s01 << s02 << s03 << s04 << s06 << s08 << endl
<< s01 << s02 << s03 << s04 << s07 << s08 << endl
<< s01 << s02 << s03 << s05 << s06 << s07 << endl
<< s01 << s02 << s03 << s05 << s06 << s08 << endl
<< s01 << s02 << s03 << s05 << s07 << s08 << endl
<< s01 << s02 << s03 << s06 << s07 << s08 << endl
<< s01 << s02 << s04 << s05 << s06 << s07 << endl
<< s01 << s02 << s04 << s05 << s06 << s08 << endl
<< s01 << s02 << s04 << s05 << s07 << s08 << endl
<< s01 << s02 << s04 << s06 << s07 << s08 << endl
<< s01 << s02 << s05 << s06 << s07 << s08 << endl
<< s01 << s03 << s04 << s05 << s06 << s07 << endl
<< s01 << s03 << s04 << s05 << s06 << s08 << endl
<< s01 << s03 << s04 << s05 << s07 << s08 << endl
<< s01 << s03 << s04 << s06 << s07 << s08 << endl
<< s01 << s03 << s05 << s06 << s07 << s08 << endl
<< s01 << s04 << s05 << s06 << s07 << s08 << endl
<< s02 << s03 << s04 << s05 << s06 << s07 << endl
<< s02 << s03 << s04 << s05 << s06 << s08 << endl
<< s02 << s03 << s04 << s05 << s07 << s08 << endl
<< s02 << s03 << s04 << s06 << s07 << s08 << endl
<< s02 << s03 << s05 << s06 << s07 << s08 << endl
<< s02 << s04 << s05 << s06 << s07 << s08 << endl
<< s03 << s04 << s05 << s06 << s07 << s08 << endl;
    file.close();
    return TRUE_N;
}

int ToSix::file9to6() {
    using namespace std;

    ofstream file( fileName.c_str() );
    if( file.fail() ) {
        return FALSE_N;
    }

file << s01 << s02 << s03 << s04 << s05 << s06 << endl
<< s01 << s02 << s03 << s04 << s05 << s07 << endl
<< s01 << s02 << s03 << s04 << s05 << s08 << endl
<< s01 << s02 << s03 << s04 << s05 << s09 << endl
<< s01 << s02 << s03 << s04 << s06 << s07 << endl
<< s01 << s02 << s03 << s04 << s06 << s08 << endl
<< s01 << s02 << s03 << s04 << s06 << s09 << endl
<< s01 << s02 << s03 << s04 << s07 << s08 << endl
<< s01 << s02 << s03 << s04 << s07 << s09 << endl
<< s01 << s02 << s03 << s04 << s08 << s09 << endl
<< s01 << s02 << s03 << s05 << s06 << s07 << endl
<< s01 << s02 << s03 << s05 << s06 << s08 << endl
<< s01 << s02 << s03 << s05 << s06 << s09 << endl
<< s01 << s02 << s03 << s05 << s07 << s08 << endl
<< s01 << s02 << s03 << s05 << s07 << s09 << endl
<< s01 << s02 << s03 << s05 << s08 << s09 << endl
<< s01 << s02 << s03 << s06 << s07 << s08 << endl
<< s01 << s02 << s03 << s06 << s07 << s09 << endl
<< s01 << s02 << s03 << s06 << s08 << s09 << endl
<< s01 << s02 << s03 << s07 << s08 << s09 << endl
<< s01 << s02 << s04 << s05 << s06 << s07 << endl
<< s01 << s02 << s04 << s05 << s06 << s08 << endl
<< s01 << s02 << s04 << s05 << s06 << s09 << endl
<< s01 << s02 << s04 << s05 << s07 << s08 << endl
<< s01 << s02 << s04 << s05 << s07 << s09 << endl
<< s01 << s02 << s04 << s05 << s08 << s09 << endl
<< s01 << s02 << s04 << s06 << s07 << s08 << endl
<< s01 << s02 << s04 << s06 << s07 << s09 << endl
<< s01 << s02 << s04 << s06 << s08 << s09 << endl
<< s01 << s02 << s04 << s07 << s08 << s09 << endl
<< s01 << s02 << s05 << s06 << s07 << s08 << endl
<< s01 << s02 << s05 << s06 << s07 << s09 << endl
<< s01 << s02 << s05 << s06 << s08 << s09 << endl
<< s01 << s02 << s05 << s07 << s08 << s09 << endl
<< s01 << s02 << s06 << s07 << s08 << s09 << endl
<< s01 << s03 << s04 << s05 << s06 << s07 << endl
<< s01 << s03 << s04 << s05 << s06 << s08 << endl
<< s01 << s03 << s04 << s05 << s06 << s09 << endl
<< s01 << s03 << s04 << s05 << s07 << s08 << endl
<< s01 << s03 << s04 << s05 << s07 << s09 << endl
<< s01 << s03 << s04 << s05 << s08 << s09 << endl
<< s01 << s03 << s04 << s06 << s07 << s08 << endl
<< s01 << s03 << s04 << s06 << s07 << s09 << endl
<< s01 << s03 << s04 << s06 << s08 << s09 << endl
<< s01 << s03 << s04 << s07 << s08 << s09 << endl
<< s01 << s03 << s05 << s06 << s07 << s08 << endl
<< s01 << s03 << s05 << s06 << s07 << s09 << endl
<< s01 << s03 << s05 << s06 << s08 << s09 << endl
<< s01 << s03 << s05 << s07 << s08 << s09 << endl
<< s01 << s03 << s06 << s07 << s08 << s09 << endl
<< s01 << s04 << s05 << s06 << s07 << s08 << endl
<< s01 << s04 << s05 << s06 << s07 << s09 << endl
<< s01 << s04 << s05 << s06 << s08 << s09 << endl
<< s01 << s04 << s05 << s07 << s08 << s09 << endl
<< s01 << s04 << s06 << s07 << s08 << s09 << endl
<< s01 << s05 << s06 << s07 << s08 << s09 << endl
<< s02 << s03 << s04 << s05 << s06 << s07 << endl
<< s02 << s03 << s04 << s05 << s06 << s08 << endl
<< s02 << s03 << s04 << s05 << s06 << s09 << endl
<< s02 << s03 << s04 << s05 << s07 << s08 << endl
<< s02 << s03 << s04 << s05 << s07 << s09 << endl
<< s02 << s03 << s04 << s05 << s08 << s09 << endl
<< s02 << s03 << s04 << s06 << s07 << s08 << endl
<< s02 << s03 << s04 << s06 << s07 << s09 << endl
<< s02 << s03 << s04 << s06 << s08 << s09 << endl
<< s02 << s03 << s04 << s07 << s08 << s09 << endl
<< s02 << s03 << s05 << s06 << s07 << s08 << endl
<< s02 << s03 << s05 << s06 << s07 << s09 << endl
<< s02 << s03 << s05 << s06 << s08 << s09 << endl
<< s02 << s03 << s05 << s07 << s08 << s09 << endl
<< s02 << s03 << s06 << s07 << s08 << s09 << endl
<< s02 << s04 << s05 << s06 << s07 << s08 << endl
<< s02 << s04 << s05 << s06 << s07 << s09 << endl
<< s02 << s04 << s05 << s06 << s08 << s09 << endl
<< s02 << s04 << s05 << s07 << s08 << s09 << endl
<< s02 << s04 << s06 << s07 << s08 << s09 << endl
<< s02 << s05 << s06 << s07 << s08 << s09 << endl
<< s03 << s04 << s05 << s06 << s07 << s08 << endl;

file << s03 << s04 << s05 << s06 << s07 << s09 << endl
<< s03 << s04 << s05 << s06 << s08 << s09 << endl
<< s03 << s04 << s05 << s07 << s08 << s09 << endl
<< s03 << s04 << s06 << s07 << s08 << s09 << endl
<< s03 << s05 << s06 << s07 << s08 << s09 << endl
<< s04 << s05 << s06 << s07 << s08 << s09 << endl;
    file.close();
    return TRUE_N;
}

int ToSix::file10to6() {
    using namespace std;

    ofstream file( fileName.c_str() );
    if( file.fail() ) {
        return FALSE_N;
    }

file << s01 << s02 << s03 << s04 << s05 << s06 << endl
<< s01 << s02 << s03 << s04 << s05 << s07 << endl
<< s01 << s02 << s03 << s04 << s05 << s08 << endl
<< s01 << s02 << s03 << s04 << s05 << s09 << endl
<< s01 << s02 << s03 << s04 << s05 << s10 << endl
<< s01 << s02 << s03 << s04 << s06 << s07 << endl
<< s01 << s02 << s03 << s04 << s06 << s08 << endl
<< s01 << s02 << s03 << s04 << s06 << s09 << endl
<< s01 << s02 << s03 << s04 << s06 << s10 << endl
<< s01 << s02 << s03 << s04 << s07 << s08 << endl
<< s01 << s02 << s03 << s04 << s07 << s09 << endl
<< s01 << s02 << s03 << s04 << s07 << s10 << endl
<< s01 << s02 << s03 << s04 << s08 << s09 << endl
<< s01 << s02 << s03 << s04 << s08 << s10 << endl
<< s01 << s02 << s03 << s04 << s09 << s10 << endl
<< s01 << s02 << s03 << s05 << s06 << s07 << endl
<< s01 << s02 << s03 << s05 << s06 << s08 << endl
<< s01 << s02 << s03 << s05 << s06 << s09 << endl
<< s01 << s02 << s03 << s05 << s06 << s10 << endl
<< s01 << s02 << s03 << s05 << s07 << s08 << endl
<< s01 << s02 << s03 << s05 << s07 << s09 << endl
<< s01 << s02 << s03 << s05 << s07 << s10 << endl
<< s01 << s02 << s03 << s05 << s08 << s09 << endl
<< s01 << s02 << s03 << s05 << s08 << s10 << endl
<< s01 << s02 << s03 << s05 << s09 << s10 << endl
<< s01 << s02 << s03 << s06 << s07 << s08 << endl
<< s01 << s02 << s03 << s06 << s07 << s09 << endl
<< s01 << s02 << s03 << s06 << s07 << s10 << endl
<< s01 << s02 << s03 << s06 << s08 << s09 << endl
<< s01 << s02 << s03 << s06 << s08 << s10 << endl
<< s01 << s02 << s03 << s06 << s09 << s10 << endl
<< s01 << s02 << s03 << s07 << s08 << s09 << endl
<< s01 << s02 << s03 << s07 << s08 << s10 << endl
<< s01 << s02 << s03 << s07 << s09 << s10 << endl
<< s01 << s02 << s03 << s08 << s09 << s10 << endl
<< s01 << s02 << s04 << s05 << s06 << s07 << endl
<< s01 << s02 << s04 << s05 << s06 << s08 << endl
<< s01 << s02 << s04 << s05 << s06 << s09 << endl
<< s01 << s02 << s04 << s05 << s06 << s10 << endl
<< s01 << s02 << s04 << s05 << s07 << s08 << endl
<< s01 << s02 << s04 << s05 << s07 << s09 << endl
<< s01 << s02 << s04 << s05 << s07 << s10 << endl
<< s01 << s02 << s04 << s05 << s08 << s09 << endl
<< s01 << s02 << s04 << s05 << s08 << s10 << endl
<< s01 << s02 << s04 << s05 << s09 << s10 << endl
<< s01 << s02 << s04 << s06 << s07 << s08 << endl
<< s01 << s02 << s04 << s06 << s07 << s09 << endl
<< s01 << s02 << s04 << s06 << s07 << s10 << endl
<< s01 << s02 << s04 << s06 << s08 << s09 << endl
<< s01 << s02 << s04 << s06 << s08 << s10 << endl
<< s01 << s02 << s04 << s06 << s09 << s10 << endl
<< s01 << s02 << s04 << s07 << s08 << s09 << endl
<< s01 << s02 << s04 << s07 << s08 << s10 << endl
<< s01 << s02 << s04 << s07 << s09 << s10 << endl
<< s01 << s02 << s04 << s08 << s09 << s10 << endl
<< s01 << s02 << s05 << s06 << s07 << s08 << endl
<< s01 << s02 << s05 << s06 << s07 << s09 << endl
<< s01 << s02 << s05 << s06 << s07 << s10 << endl
<< s01 << s02 << s05 << s06 << s08 << s09 << endl
<< s01 << s02 << s05 << s06 << s08 << s10 << endl
<< s01 << s02 << s05 << s06 << s09 << s10 << endl
<< s01 << s02 << s05 << s07 << s08 << s09 << endl
<< s01 << s02 << s05 << s07 << s08 << s10 << endl
<< s01 << s02 << s05 << s07 << s09 << s10 << endl
<< s01 << s02 << s05 << s08 << s09 << s10 << endl
<< s01 << s02 << s06 << s07 << s08 << s09 << endl
<< s01 << s02 << s06 << s07 << s08 << s10 << endl
<< s01 << s02 << s06 << s07 << s09 << s10 << endl
<< s01 << s02 << s06 << s08 << s09 << s10 << endl
<< s01 << s02 << s07 << s08 << s09 << s10 << endl
<< s01 << s03 << s04 << s05 << s06 << s07 << endl
<< s01 << s03 << s04 << s05 << s06 << s08 << endl
<< s01 << s03 << s04 << s05 << s06 << s09 << endl
<< s01 << s03 << s04 << s05 << s06 << s10 << endl
<< s01 << s03 << s04 << s05 << s07 << s08 << endl
<< s01 << s03 << s04 << s05 << s07 << s09 << endl
<< s01 << s03 << s04 << s05 << s07 << s10 << endl
<< s01 << s03 << s04 << s05 << s08 << s09 << endl;

file << s01 << s03 << s04 << s05 << s08 << s10 << endl
<< s01 << s03 << s04 << s05 << s09 << s10 << endl
<< s01 << s03 << s04 << s06 << s07 << s08 << endl
<< s01 << s03 << s04 << s06 << s07 << s09 << endl
<< s01 << s03 << s04 << s06 << s07 << s10 << endl
<< s01 << s03 << s04 << s06 << s08 << s09 << endl
<< s01 << s03 << s04 << s06 << s08 << s10 << endl
<< s01 << s03 << s04 << s06 << s09 << s10 << endl
<< s01 << s03 << s04 << s07 << s08 << s09 << endl
<< s01 << s03 << s04 << s07 << s08 << s10 << endl
<< s01 << s03 << s04 << s07 << s09 << s10 << endl
<< s01 << s03 << s04 << s08 << s09 << s10 << endl
<< s01 << s03 << s05 << s06 << s07 << s08 << endl
<< s01 << s03 << s05 << s06 << s07 << s09 << endl
<< s01 << s03 << s05 << s06 << s07 << s10 << endl
<< s01 << s03 << s05 << s06 << s08 << s09 << endl
<< s01 << s03 << s05 << s06 << s08 << s10 << endl
<< s01 << s03 << s05 << s06 << s09 << s10 << endl
<< s01 << s03 << s05 << s07 << s08 << s09 << endl
<< s01 << s03 << s05 << s07 << s08 << s10 << endl
<< s01 << s03 << s05 << s07 << s09 << s10 << endl
<< s01 << s03 << s05 << s08 << s09 << s10 << endl
<< s01 << s03 << s06 << s07 << s08 << s09 << endl
<< s01 << s03 << s06 << s07 << s08 << s10 << endl
<< s01 << s03 << s06 << s07 << s09 << s10 << endl
<< s01 << s03 << s06 << s08 << s09 << s10 << endl
<< s01 << s03 << s07 << s08 << s09 << s10 << endl
<< s01 << s04 << s05 << s06 << s07 << s08 << endl
<< s01 << s04 << s05 << s06 << s07 << s09 << endl
<< s01 << s04 << s05 << s06 << s07 << s10 << endl
<< s01 << s04 << s05 << s06 << s08 << s09 << endl
<< s01 << s04 << s05 << s06 << s08 << s10 << endl
<< s01 << s04 << s05 << s06 << s09 << s10 << endl
<< s01 << s04 << s05 << s07 << s08 << s09 << endl
<< s01 << s04 << s05 << s07 << s08 << s10 << endl
<< s01 << s04 << s05 << s07 << s09 << s10 << endl
<< s01 << s04 << s05 << s08 << s09 << s10 << endl
<< s01 << s04 << s06 << s07 << s08 << s09 << endl
<< s01 << s04 << s06 << s07 << s08 << s10 << endl
<< s01 << s04 << s06 << s07 << s09 << s10 << endl
<< s01 << s04 << s06 << s08 << s09 << s10 << endl
<< s01 << s04 << s07 << s08 << s09 << s10 << endl
<< s01 << s05 << s06 << s07 << s08 << s09 << endl
<< s01 << s05 << s06 << s07 << s08 << s10 << endl
<< s01 << s05 << s06 << s07 << s09 << s10 << endl
<< s01 << s05 << s06 << s08 << s09 << s10 << endl
<< s01 << s05 << s07 << s08 << s09 << s10 << endl
<< s01 << s06 << s07 << s08 << s09 << s10 << endl
<< s02 << s03 << s04 << s05 << s06 << s07 << endl
<< s02 << s03 << s04 << s05 << s06 << s08 << endl
<< s02 << s03 << s04 << s05 << s06 << s09 << endl
<< s02 << s03 << s04 << s05 << s06 << s10 << endl
<< s02 << s03 << s04 << s05 << s07 << s08 << endl
<< s02 << s03 << s04 << s05 << s07 << s09 << endl
<< s02 << s03 << s04 << s05 << s07 << s10 << endl
<< s02 << s03 << s04 << s05 << s08 << s09 << endl
<< s02 << s03 << s04 << s05 << s08 << s10 << endl
<< s02 << s03 << s04 << s05 << s09 << s10 << endl
<< s02 << s03 << s04 << s06 << s07 << s08 << endl
<< s02 << s03 << s04 << s06 << s07 << s09 << endl
<< s02 << s03 << s04 << s06 << s07 << s10 << endl
<< s02 << s03 << s04 << s06 << s08 << s09 << endl
<< s02 << s03 << s04 << s06 << s08 << s10 << endl
<< s02 << s03 << s04 << s06 << s09 << s10 << endl
<< s02 << s03 << s04 << s07 << s08 << s09 << endl
<< s02 << s03 << s04 << s07 << s08 << s10 << endl
<< s02 << s03 << s04 << s07 << s09 << s10 << endl
<< s02 << s03 << s04 << s08 << s09 << s10 << endl
<< s02 << s03 << s05 << s06 << s07 << s08 << endl
<< s02 << s03 << s05 << s06 << s07 << s09 << endl
<< s02 << s03 << s05 << s06 << s07 << s10 << endl
<< s02 << s03 << s05 << s06 << s08 << s09 << endl
<< s02 << s03 << s05 << s06 << s08 << s10 << endl
<< s02 << s03 << s05 << s06 << s09 << s10 << endl
<< s02 << s03 << s05 << s07 << s08 << s09 << endl
<< s02 << s03 << s05 << s07 << s08 << s10 << endl
<< s02 << s03 << s05 << s07 << s09 << s10 << endl
<< s02 << s03 << s05 << s08 << s09 << s10 << endl;

file << s02 << s03 << s06 << s07 << s08 << s09 << endl
<< s02 << s03 << s06 << s07 << s08 << s10 << endl
<< s02 << s03 << s06 << s07 << s09 << s10 << endl
<< s02 << s03 << s06 << s08 << s09 << s10 << endl
<< s02 << s03 << s07 << s08 << s09 << s10 << endl
<< s02 << s04 << s05 << s06 << s07 << s08 << endl
<< s02 << s04 << s05 << s06 << s07 << s09 << endl
<< s02 << s04 << s05 << s06 << s07 << s10 << endl
<< s02 << s04 << s05 << s06 << s08 << s09 << endl
<< s02 << s04 << s05 << s06 << s08 << s10 << endl
<< s02 << s04 << s05 << s06 << s09 << s10 << endl
<< s02 << s04 << s05 << s07 << s08 << s09 << endl
<< s02 << s04 << s05 << s07 << s08 << s10 << endl
<< s02 << s04 << s05 << s07 << s09 << s10 << endl
<< s02 << s04 << s05 << s08 << s09 << s10 << endl
<< s02 << s04 << s06 << s07 << s08 << s09 << endl
<< s02 << s04 << s06 << s07 << s08 << s10 << endl
<< s02 << s04 << s06 << s07 << s09 << s10 << endl
<< s02 << s04 << s06 << s08 << s09 << s10 << endl
<< s02 << s04 << s07 << s08 << s09 << s10 << endl
<< s02 << s05 << s06 << s07 << s08 << s09 << endl
<< s02 << s05 << s06 << s07 << s08 << s10 << endl
<< s02 << s05 << s06 << s07 << s09 << s10 << endl
<< s02 << s05 << s06 << s08 << s09 << s10 << endl
<< s02 << s05 << s07 << s08 << s09 << s10 << endl
<< s02 << s06 << s07 << s08 << s09 << s10 << endl
<< s03 << s04 << s05 << s06 << s07 << s08 << endl
<< s03 << s04 << s05 << s06 << s07 << s09 << endl
<< s03 << s04 << s05 << s06 << s07 << s10 << endl
<< s03 << s04 << s05 << s06 << s08 << s09 << endl
<< s03 << s04 << s05 << s06 << s08 << s10 << endl
<< s03 << s04 << s05 << s06 << s09 << s10 << endl
<< s03 << s04 << s05 << s07 << s08 << s09 << endl
<< s03 << s04 << s05 << s07 << s08 << s10 << endl
<< s03 << s04 << s05 << s07 << s09 << s10 << endl
<< s03 << s04 << s05 << s08 << s09 << s10 << endl
<< s03 << s04 << s06 << s07 << s08 << s09 << endl
<< s03 << s04 << s06 << s07 << s08 << s10 << endl
<< s03 << s04 << s06 << s07 << s09 << s10 << endl
<< s03 << s04 << s06 << s08 << s09 << s10 << endl
<< s03 << s04 << s07 << s08 << s09 << s10 << endl
<< s03 << s05 << s06 << s07 << s08 << s09 << endl
<< s03 << s05 << s06 << s07 << s08 << s10 << endl
<< s03 << s05 << s06 << s07 << s09 << s10 << endl
<< s03 << s05 << s06 << s08 << s09 << s10 << endl
<< s03 << s05 << s07 << s08 << s09 << s10 << endl
<< s03 << s06 << s07 << s08 << s09 << s10 << endl
<< s04 << s05 << s06 << s07 << s08 << s09 << endl
<< s04 << s05 << s06 << s07 << s08 << s10 << endl
<< s04 << s05 << s06 << s07 << s09 << s10 << endl
<< s04 << s05 << s06 << s08 << s09 << s10 << endl
<< s04 << s05 << s07 << s08 << s09 << s10 << endl
<< s04 << s06 << s07 << s08 << s09 << s10 << endl
<< s05 << s06 << s07 << s08 << s09 << s10 << endl;
    file.close();
    return TRUE_N;
}
