#ifndef XORSHIFT_H
#define XORSHIFT_H

/*
In 2003, xorshift was discovered by George Marsaglia.
good C random number generator
Date: 2003-05-13 08:55:05 PST
http://school.anhb.uwa.edu.au/personalpages/kwessen/shared/Marsaglia03.html

xorshift.pdf
http://www.jstatsoft.org/v08/i14/paper
- quote -
the xorshift:
unsigned long xor128(){
static unsigned long x=123456789,y=362436069,z=521288629,w=88675123;
unsigned long t;
t=(x^(x<<11));x=y;y=z;z=w; return( w=(w^(w>>19))^(t^(t>>8)) );
}
- unquote -

*/


#define SEED_MASK 0xF423FL
#define START_FROM_1 123456789
#define START_FROM_3 362436069
#define START_FROM_5 521288629
#define START_FROM_8 88675123

#pragma warn -8012 // Borland C++ 5.5.1 for Win32
#include <math.h>
#include <time.h>

class Xorshift {
    unsigned int seeding;
    unsigned long x, y, z, w;

public:
    unsigned int nextRandom() {
        unsigned long t;
        t = x ^ (x << 11);
        x = y;
        y = z;
        z = w;
        w = ( w ^ (w >> 19) ) ^ (t ^ (t >> 8) );

        unsigned int n = (unsigned int)w;
        return n;
    }

    ~Xorshift(){}
    Xorshift(unsigned int s);
};

#endif // XORSHIFT_H
