#ifndef RESU_H
#define RESU_H

#define FIRST_BYTE 1
#define KANA_KUTEN 0xA1
#define LONG_LIST_SIZE 100
#define LOTO_6_COUNT 43
#define PROVIDED_SIZE 6
#define RING_COUNT 3
#define SECOND_BYTE 2
#define TO_BUFFER_SIZE 384
#define TOKOBI_SIZE 6
#include <algorithm>
#include <deque>
#include <map>
#include <vector>
#include "Characte.h"
#include "Numbered.h"
#include "OS-specific.h"
#include "TimeName.h"
#include "ToFive.h"
#include "ToSeven.h"
#include "ToSix.h"

typedef std::deque<std::string> RING;
typedef std::map<std::string, int> ZENKAKU_HANKAKU;
typedef std::vector<int> COUNT;
typedef std::vector<signed char> PLACE;
typedef std::vector<std::string> ITEM;

class Alterable {
protected:
    bool firstLine, matrix, NO_SPLITTING, serialNumber, whoText;
    bool check[ LOTO_6_COUNT + 1 ];
    COUNT count;
    int all, itemCount, loto, NEIGHBOR, NEW_LINE_LENGTH, OMIT, period, span;
    ITEM article, item;
    PLACE place;
    std::string ANCHOR, BEFORE, BELL, CLOSE_BRACKET, COLON, EMPTY, error, GAP, list_of_items, MARK, MINUS, NEW_LINE, REMOVE_LINE_1, saveName, sequence, TOKOBI, whose, WHO_TEXT;
    std::string ball[ LOTO_6_COUNT + 1 ];
    std::stringstream *buffer;
    std::stringstream *combos;

    void add(std::string & s) {
        *combos << s << NEW_LINE;
    }

    void clear(std::string & s) {
        delete combos;
        combos = new std::stringstream();
        whose = s;
    }

    void listing() {
        std::string c = combos->str();
        *buffer << whose << NEW_LINE << c;
    }

    void listing(std::string & extra) {
        std::string c = combos->str();
        *buffer << whose << NEW_LINE << c << extra;
    }

    bool openSaveClose(std::string & fileName);
    bool readingToProduceArray();
    bool searchingItem(std::string & s);
    bool searchingItemSequence(std::string & s);
    int checkLine1(std::string & line);
    std::string countMeasureSort(std::string & s);
    void resettingArrays();
    void resettingPlaceArray();
    void settingArrays();

public:
    virtual ~Alterable(){}

    int getLoto() const {
        return loto;
    }

    std::string altered() const {
        return saveName;
    }

    std::string inquiry() const {
        return error;
    }

    std::string getSequence() const {
        return sequence;
    }

    void setting(std::string & l, int p, bool f, bool m, bool s, bool w) {
        using namespace std;

        const string an(">>");
        const string b00("bO"); const string b01("01"); const string b02("02"); const string b03("03"); const string b04("04"); const string b05("05"); const string b06("06"); const string b07("07"); const string b08("08"); const string b09("09"); 
        const string b10("10"); const string b11("11"); const string b12("12"); const string b13("13"); const string b14("14"); const string b15("15"); const string b16("16"); const string b17("17"); const string b18("18"); const string b19("19"); 
        const string b20("20"); const string b21("21"); const string b22("22"); const string b23("23"); const string b24("24"); const string b25("25"); const string b26("26"); const string b27("27"); const string b28("28"); const string b29("29"); 
        const string b30("30"); const string b31("31"); const string b32("32"); const string b33("33"); const string b34("34"); const string b35("35"); const string b36("36"); const string b37("37"); const string b38("38"); const string b39("39"); 
        const string b40("40"); const string b41("41"); const string b42("42"); const string b43("43"); 
        const string be("F");
        const string bel("\\a");
        const string cl(" )");
        const string co(":");
        const string em("");
        const string ga(" ");
        const string ma("^");
        const string mi("-");
        const string ne("\n");
        const string re("-1-");
        const string te(".txt");
        const string to("e");
        const string wh("who.txt");

        ANCHOR = an;
        ball[0] = b00; ball[1] = b01; ball[2] = b02; ball[3] = b03; ball[4] = b04; ball[5] = b05; ball[6] = b06; ball[7] = b07; ball[8] = b08; ball[9] = b09; 
        ball[10] = b10; ball[11] = b11; ball[12] = b12; ball[13] = b13; ball[14] = b14; ball[15] = b15; ball[16] = b16; ball[17] = b17; ball[18] = b18; ball[19] = b19; 
        ball[20] = b20; ball[21] = b21; ball[22] = b22; ball[23] = b23; ball[24] = b24; ball[25] = b25; ball[26] = b26; ball[27] = b27; ball[28] = b28; ball[29] = b29; 
        ball[30] = b30; ball[31] = b31; ball[32] = b32; ball[33] = b33; ball[34] = b34; ball[35] = b35; ball[36] = b36; ball[37] = b37; ball[38] = b38; ball[39] = b39; 
        ball[40] = b40; ball[41] = b41; ball[42] = b42; ball[43] = b43; 
        BEFORE = be;
        BELL = bel;
        CLOSE_BRACKET = cl;
        COLON = co;
        EMPTY = em;
        firstLine = f;
        GAP = ga;
        list_of_items = l;
        MARK = ma;
        matrix = m;
        MINUS = mi;
        NEIGHBOR = 2;
        NEW_LINE = ne;
        NEW_LINE_LENGTH = NEW_LINE.length();
        NO_SPLITTING = true;
        OMIT = string::npos;
        period = p;
        REMOVE_LINE_1 = re;
        saveName = em;
        serialNumber = s;
        TOKOBI = to;
        whoText = w;
        WHO_TEXT = wh;
    }

    virtual bool altering(std::string & fileName) = 0;
};

class ASCIIdates : public Alterable {
    const std::string ASCII, fr, mo, sa, su, th, tu, ve, we, YOBI_BEFORE_AFTER;
    std::string weekdays[9];

    std::string asciiOnly(std::string &);

public:
    bool altering(std::string & fileName);

    ~ASCIIdates(){}

    ASCIIdates(): ASCII(" !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~"), su("Sun"), mo("Mon"), tu("Tue"), we("Wed"), th("Thu"), fr("Fri"), sa("Sat"), ve("|"), YOBI_BEFORE_AFTER("ΐ؋yFb") {
        buffer = new std::stringstream();
        weekdays[0] = su;
        weekdays[1] = mo;
        weekdays[2] = tu;
        weekdays[3] = we;
        weekdays[4] = th;
        weekdays[5] = fr;
        weekdays[6] = sa;
        weekdays[7] = ve;
        weekdays[8] = ve;
    }

};

class BetweenColons : public Alterable {
public:
    bool altering(std::string & fileName);

    ~BetweenColons(){}
    BetweenColons() {
        buffer = new std::stringstream();
        combos = new std::stringstream();
        whose = EMPTY;
    }

};

class Combo : public Alterable {
    const bool SERIAL_NUMBER;
    const std::string BOX_10TO6, BOX_10TO7, BOX_11TO7, BOX_6TO5, BOX_7TO5, BOX_7TO6, BOX_8TO5, BOX_8TO6, BOX_8TO7, BOX_9TO5, BOX_9TO6, BOX_9TO7, co;
    int result;
    std::string COMBINATION;
    std::map<std::string, int> ballCount;

    bool acquireFromFile(std::string & fileName);
    std::string firstNumberTrimmed(std::string & l);
    void produceArrays();

public:
    bool altering(std::string & fileName);

    ~Combo(){}
    Combo(): BOX_10TO6("10to6"), BOX_10TO7("10to7"), BOX_11TO7("11to7"), BOX_6TO5("6to5"), BOX_7TO5("7to5"), BOX_7TO6("7to6"), BOX_8TO5("8to5"), BOX_8TO6("8to6"), BOX_8TO7("8to7"), BOX_9TO5("9to5"), BOX_9TO6("9to6"), BOX_9TO7("9to7"), co("cmb"), SERIAL_NUMBER(true) {
        buffer = new std::stringstream();
        COMBINATION = co;
        combos = new std::stringstream();
        whose = EMPTY;
    }

};

class CombosDates : public Alterable {

    bool countBallsMesureSpan(std::string & s);

public:
    bool altering(std::string & fileName);

    ~CombosDates(){}
    CombosDates() {
        buffer = new std::stringstream();
        combos = new std::stringstream();
        whose = EMPTY;
    }

};

class DateFollowedByName : public Alterable {
public:
    bool altering(std::string & fileName);

    ~DateFollowedByName(){}
    DateFollowedByName() {
        buffer = new std::stringstream();
        combos = new std::stringstream();
        whose = EMPTY;
    }

};

class Dates : public Alterable {
public:
    bool altering(std::string & fileName);

    ~Dates(){}
    Dates() {
        buffer = new std::stringstream();
    }

};

class Drafo : public Alterable {
    ITEM draft, formal;
    ZENKAKU_HANKAKU z;

    bool readingCsvToProduceArrays();
    std::string checkOneByOne(std::string & line);
    std::string replaceDraftWithFormal(std::string & line);

public:
    bool altering(std::string & fileName);

    ~Drafo(){}
    Drafo();
};

class ExcludeText : public Alterable {
public:
    bool altering(std::string & fileName);

    ~ExcludeText(){}
    ExcludeText();
};

class FormDateLine : public Alterable {
    const std::string ID_COLON;
    RING ring;

    int produceRingBuffer(int size);
    void blankRingBuffer();

public:
    bool altering(std::string & fileName);

    ~FormDateLine(){}
    FormDateLine(): ID_COLON(" ID:") {
        buffer = new std::stringstream();
        combos = new std::stringstream();
        whose = EMPTY;
    }

};

class NewLines : public Alterable {
    const bool NOT_AXIAL;

public:
    bool altering(std::string & fileName);

    ~NewLines(){}
    NewLines();
};

class QuoteRatherThanMark : public Alterable {
    const std::string BACK_QUOTE;

    std::string replaceMARKwithBACK_QUOTE(std::string & line);

public:
    bool altering(std::string & fileName);

    ~QuoteRatherThanMark(){}
    QuoteRatherThanMark(): BACK_QUOTE("`") {
        buffer = new std::stringstream();
    }

};

class Segmentalize : public Alterable {
    bool integrity_of_data(std::string & p);
    const int NON_INDEX_NUMBER;
    const std::string CELL_01_02_03_04_05, CELL_16_17_18_19_20, CELL_26_27_28_29_30, SENTINEL;
    int row;

public:
    bool altering(std::string & fileName);

    ~Segmentalize(){}
    Segmentalize(): CELL_01_02_03_04_05("01 02 03 04 05 "), CELL_16_17_18_19_20("16 17 18 19 20 "), CELL_26_27_28_29_30("26 27 28 29 30 "), NON_INDEX_NUMBER(3), SENTINEL("41") {
        buffer = new std::stringstream();
        combos = new std::stringstream();
        whose = EMPTY;
    }

};

class TableReverseSorted : public Alterable {
    const std::string REVERSE, ta;
    COUNT countCopied;
    long a[LONG_LIST_SIZE];
    std::string TABLE;

    void longList(std::string & s, const char *d, long *a);
    void settingThreeArrays();

public:
    bool altering(std::string & fileName);

    ~TableReverseSorted(){}
    TableReverseSorted();
};

class UniqueCombos : public Alterable {
    const std::string un;
    std::string UNIQUE;

public:
    bool altering(std::string & fileName);

    ~UniqueCombos(){}
    UniqueCombos();
};

bool integrity_of_data(char *p);
bool removeTemporaryFiles();
int stringToInteger(std::string & data);
int zenkakuFragment(std::string & s, int mark_index, int mark);
bool testDrafoText();
bool testExcludeText();
bool testSeparateText();
bool testTabulateText();
bool testUniqueText();
void guide(bool comments);

#endif // RESU_H
